Target version: 5.0.0   
Description

I suggest including the avatar URL in the user's API.

{

  "user": {

    "id": 1,

    "login": "admin",

    "firstname": "Redmine",

    "lastname": "Admin",

    "created_on": "2006-07-19T17:12:21Z",

    "updated_on": "2021-12-13T10:03:30Z",

    "last_login_on": "2021-12-11T07:06:41Z",

    "passwd_changed_on": null,

    "avatar_url": "https://www.gravatar.com/avatar/982b6086063a22d85509455d8e31cca2" 

  }

}

 Currently, it is difficult to display a user's Gravatar image when developing an application using the REST API. This is because Users

API response doesn't include Gravatar URL. Although you can generate a Gravatar URL if you know the email address, email

addresses are usually hidden for non-admin users.

This feature is very useful for developers who are building Redmine clients using REST API.

Related issues:

Related to Redmine - Defect #37157: Internal server error when trying to retr... Closed

Associated revisions

Revision 21375 - 2022-01-21 01:31 - Go MAEDA

Include avatar URL in Users API (#36303).

Contributed by Yuichi HARADA.

History

#1 - 2021-12-22 06:09 - Yuichi HARADA

- File 36303.patch added

With the following patch, get the avatar URL even by non-admin users.

diff --git a/app/views/users/index.api.rsb b/app/views/users/index.api.rsb

index 4b51ba47a8..cd89a6bf9c 100644

--- a/app/views/users/index.api.rsb

+++ b/app/views/users/index.api.rsb

@@ -11,6 +11,7 @@ api.array :users, api_meta(:total_count => @user_count, :offset => @offset, :lim

       api.updated_on user.updated_on

       api.last_login_on     user.last_login_on

       api.passwd_changed_on user.passwd_changed_on

+      api.avatar_url gravatar_url(user.mail, {rating: nil, size: nil})

       api.twofa_scheme user.twofa_scheme

       render_api_custom_values user.visible_custom_field_values, api

diff --git a/app/views/users/show.api.rsb b/app/views/users/show.api.rsb

index a19a8c637a..c30947512e 100644
--- a/app/views/users/show.api.rsb

+++ b/app/views/users/show.api.rsb

@@ -9,6 +9,7 @@ api.user do

   api.updated_on @user.updated_on

   api.last_login_on     @user.last_login_on

   api.passwd_changed_on @user.passwd_changed_on

+  api.avatar_url gravatar_url(@user.mail, {rating: nil, size: nil})

   api.twofa_scheme      @user.twofa_scheme if User.current.admin? || (User.current == @user)

   api.api_key    @user.api_key if User.current.admin? || (User.current == @user)

   api.status     @user.status if User.current.admin?

#2 - 2021-12-30 10:20 - Go MAEDA

- File 36303-v2.patch added

- Target version set to Candidate for next major release

Updated the patch to check if the setting "Use Gravatar user icons" is enabled.

#3 - 2022-01-02 15:32 - Go MAEDA

- Target version changed from Candidate for next major release to 5.0.0

Setting the target version to 5.0.0.

#4 - 2022-01-06 02:43 - Go MAEDA

The patch should respect Setting.Setting.gravatar_default. Otherwise, the icon you see in Redmine and the icon you get by accessing the avatar_url

returned by the API will be different.

#5 - 2022-01-06 02:54 - Yuichi HARADA

Go MAEDA wrote:

The patch should respect Setting.Setting.gravatar_default. Otherwise, the icon you see in Redmine and the icon you get by accessing the

avatar_url returned by the API will be different.

 You're right. Setting.Setting.gravatar_default should be respected.

#6 - 2022-01-20 14:54 - Go MAEDA

- File 36303-v3.patch added

Updated the patch to respect Setting.Setting.gravatar_default.

#7 - 2022-01-21 01:31 - Go MAEDA

- Subject changed from Include avatar URL in user API  to Include avatar URL in Users API

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

#8 - 2022-05-24 06:29 - Alex Moroz

Crashes here, if user is Anonimous (user.mail = nil)

api.avatar_url gravatar_url(@user.mail, {rating: nil, size: nil})

#9 - 2022-05-25 03:06 - Go MAEDA

- Related to Defect #37157: Internal server error when trying to retrieve AnonymousUser's information via Users API added

Files

36303.patch 2.96 KB 2021-12-22 Yuichi HARADA

36303-v2.patch 3.14 KB 2021-12-30 Go MAEDA

36303-v3.patch 3.29 KB 2022-01-20 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

